Unit AIG1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AIG1R(var A :Array of Real; var S :Array of Integer;
                N :Integer); 
implementation

procedure AIG1R(var A :Array of Real; var S :Array of Integer;
                N :Integer);
var
F,G,O,P,Q,BA,J,I,M,L,K :Integer;
U,Y,BH,V,BB,W :Real;
const
ZERO :Real = 0.0E0;
label
_1,_2,_21,_3,_4,_5,_6,_22,_7,_8,_9,_23,_10,_24,_11,_12,_13,_14,_15;
begin
if ( N = 1 ) 
 then goto _14;
F := 1;
G := 1;
_1:
J := G;
Q := F;
U := ZERO;
if ( F > N ) 
 then goto _21;
for I:=F to N do
 begin
  Y := Abs(A[(I-1)+(J-1)*N]);
  if ( U >= Y ) 
   then goto _2;
  U := Y;
  Q := I;
_2:
 end;
_21:
for J:=1 to N do
 begin
  BH := A[(Q-1)+(J-1)*N];
  A[(Q-1)+(J-1)*N] := A[(F-1)+(J-1)*N];
_3:
  A[(F-1)+(J-1)*N] := BH;
 end;
S[F-1] := Q;
J := G;
V := 1.0/A[(F-1)+(F-1)*N];
for I:=1 to N do
 begin
_4:
  A[(I-1)+(F-1)*N] := -(A[(I-1)+(F-1)*N]*V);
 end;
A[(F-1)+(F-1)*N] := V;
M := 0;
_5:
M := M+1;
if ( M = F ) 
 then goto _5;
if ( N < M ) 
 then goto _8;
BB := A[(F-1)+(M-1)*N];
BA := F-1;
if ( BA = 0 ) 
 then goto _22;
for O:=1 to BA do
 begin
_6:
  A[(O-1)+(M-1)*N] := A[(O-1)+(M-1)*N]+A[(O-1)+(F-1)*N]*BB;
 end;
_22:
BA := F+1;
if ( BA > N ) 
 then goto _5;
for O:=BA to N do
 begin
_7:
  A[(O-1)+(M-1)*N] := A[(O-1)+(M-1)*N]+A[(O-1)+(F-1)*N]*BB;
 end;
goto _5;
_8:
L := J+1;
if ( L > N ) 
 then goto _23;
for M:=L to N do
 begin
_9:
  A[(F-1)+(M-1)*N] := A[(F-1)+(M-1)*N]*A[(F-1)+(G-1)*N];
 end;
_23:
L := J-1;
if ( L = 0 ) 
 then goto _24;
for M:=1 to L do
 begin
_10:
  A[(F-1)+(M-1)*N] := A[(F-1)+(M-1)*N]*A[(F-1)+(G-1)*N];
 end;
_24:
F := F+1;
G := G+1;
if ( F > N ) 
 then goto _11;
if ( G <= N ) 
 then goto _1;
_11:
I := 1;
_12:
P := IntSign(1,1-N);
K := N-P;
_13:
K := K+P;
J := S[K-1];
W := A[(I-1)+(J-1)*N];
A[(I-1)+(J-1)*N] := A[(I-1)+(K-1)*N];
A[(I-1)+(K-1)*N] := W;
if ( K <> 1 ) 
 then goto _13;
I := I+1;
if ( I <= N ) 
 then goto _12;
goto _15;
_14:
A[(1-1)+(1-1)*N] := 1.0/A[(1-1)+(1-1)*N];
_15:
end;

end.
